<!DOCTYPE html>
<html>

<head lang="en">
    <meta charset="UTF-8">
    <title>Acad276 Practical Exam: Search & Results</title>
    <style>
        h1 {
            margin: auto;
            text-align: center;
            background-color: #900;
            color: #FC0;
            line-height: 60px;
        }
        h2 {
            margin: auto;
            text-align: center;
            padding: 30px;
        }
        .container {
            width: 600px;
            margin: auto;
            border: 1px solid red;
        }
        .label, .input {
            float: left;
            width: 130px;
            margin: 3px;
        }
        .label {
            margin-left: 40px;
        }
        .input>input, .input>select {
            width: 100%;
        }
        .search-submit {
            margin-top: 20px;
            margin-left: 170px;
            width: 80px;
        }
        table {
            margin: auto;
            margin-bottom: 20px;
            width: 80%;
            border-collapse: collapse;
        }
        th, td {
            border: 1px solid #900;
            padding: 10px;
            text-align: center;
        }
        .num-results {
            margin: 20px 10px;
        }
        .nav-link {
            margin: 10px 0px;
            font-size: 14px;
        }
    </style>
</head>

<body>

<div class="container">
    <h1>Mobile Devices Database</h1>

    <?php
    $mysql = new mysqli("webdev.iyaserver.com", "dent_guest", "Acad276_Dev2Ex@m", "dent_exam");
    if ($mysql->connect_errno) {
        echo "Failed to connect to MySQL: " . $mysql->connect_error;
        exit();
    }

    if ($_SERVER['REQUEST_METHOD'] == 'GET' && !isset($_GET['search'])) {
        ?>
        <h2>Search the Database</h2>
        <form method="get" action="">
            <div class="label">Device Name:</div>
            <div class="input">
                <input type="text" name="device_name"/>
            </div>
            <br clear="all"/>

            <div class="label">Manufacturer:</div>
            <div class="input">
                <select name="manufacturer_id">
                    <option value='all'>All</option>
                    <?php

                    $sql = "SELECT manufacturer_id, name FROM manufacturers";
                    $results = $mysql->query($sql);
                    if (!$results) {
                        echo "Error: " . $mysql->error;
                    } else {
                        while ($row = $results->fetch_assoc()) {
                            echo "<option value='" . $row['manufacturer_id'] . "'>" . $row['name'] . "</option>";
                        }
                    }
                    ?>
                </select>
            </div>
            <br clear="all"/>

            <div class="label">Operating System:</div>
            <div class="input">
                <select name="system_id">
                    <option value='all'>All</option>
                    <?php

                    $sql = "SELECT system_id, name FROM operating_systems";
                    $results = $mysql->query($sql);
                    if (!$results) {
                        echo "Error: " . $mysql->error;
                    } else {
                        while ($row = $results->fetch_assoc()) {
                            echo "<option value='" . $row['system_id'] . "'>" . $row['name'] . "</option>";
                        }
                    }
                    ?>
                </select>
            </div>
            <br clear="all"/>

            <div class="label">Type:</div>
            <div class="input">
                <select name="type_id">
                    <option value='all'>All</option>
                    <?php

                    $sql = "SELECT type_id, name FROM types";
                    $results = $mysql->query($sql);
                    if (!$results) {
                        echo "Error: " . $mysql->error;
                    } else {
                        while ($row = $results->fetch_assoc()) {
                            echo "<option value='" . $row['type_id'] . "'>" . $row['name'] . "</option>";
                        }
                    }
                    ?>
                </select>
            </div>
            <br clear="all"/>

            <input class="search-submit" type="submit" name="search" value="Search"/>
        </form>

        <?php
    } else {

        if (!empty($_GET['device_name']) || !empty($_GET['manufacturer_id']) || !empty($_GET['system_id']) || !empty($_GET['type_id'])) {
            $sql = "SELECT * FROM devices WHERE 1=1";

            if (!empty($_GET['device_name'])) {
                $device_name = $mysql->real_escape_string($_GET['device_name']);
                $sql .= " AND name LIKE '%$device_name%'";
            }
            if ($_GET['manufacturer_id'] != 'all') {
                $manufacturer_id = $mysql->real_escape_string($_GET['manufacturer_id']);
                $sql .= " AND manufacturer_id = '$manufacturer_id'";
            }
            if ($_GET['system_id'] != 'all') {
                $system_id = $mysql->real_escape_string($_GET['system_id']);
                $sql .= " AND system_id = '$system_id'";
            }
            if ($_GET['type_id'] != 'all') {
                $type_id = $mysql->real_escape_string($_GET['type_id']);
                $sql .= " AND type_id = '$type_id'";
            }

            $results = $mysql->query($sql);

            if (!$results) {
                echo "Error: " . $mysql->error;
                exit();
            }

            echo "<div class='num-results'>Your search returned <strong>" . $results->num_rows . "</strong> results.</div>";

            if ($results->num_rows > 0) {
                echo "<table>";
                echo "<tr><th>Name</th><th>Price</th><th>Manufacturer</th><th>System</th><th>Type</th></tr>";
                while ($row = $results->fetch_assoc()) {
                    echo "<tr>";
                    echo "<td><a href='details.php?id=" . $row['device_id'] . "'>" . $row['name'] . "</a></td>";
                    echo "<td>" . $row['price'] . "</td>";
                    echo "<td>" . $row['manufacturer_id'] . "</td>"; // Replace with a JOIN to show manufacturer name
                    echo "<td>" . $row['system_id'] . "</td>"; // Replace with a JOIN to show system name
                    echo "<td>" . $row['type_id'] . "</td>"; // Replace with a JOIN to show type name
                    echo "</tr>";
                }
                echo "</table>";
            } else {
                echo "<p>No results found.</p>";
            }
        } else {
            echo "Error: All fields must be selected.";
        }
    }
    ?>
</div>

</body>
</html>
